

   MEMBER('QueueRecord.clw')                               ! This is a MEMBER module


   INCLUDE('ABTOOLBA.INC'),ONCE
   INCLUDE('ABWINDOW.INC'),ONCE

                     MAP
                       INCLUDE('QUEUERECORD001.INC'),ONCE        !Local module procedure declarations
                     END


Main PROCEDURE                                             ! Generated from procedure template - Frame

AppFrame             APPLICATION('Application'),AT(,,310,190),FONT('Microsoft Sans Serif',10,,FONT:regular,CHARSET:DEFAULT), |
  RESIZE,MAX,STATUS(-1,80,120,45),SYSTEM,IMM
                       MENUBAR,USE(?MENUBAR1)
                         MENU('&File'),USE(?FileMenu)
                           ITEM('P&rint Setup...'),USE(?PrintSetup),MSG('Setup Printer'),STD(STD:PrintSetup)
                           ITEM,USE(?SEPARATOR1),SEPARATOR
                           ITEM('E&xit'),USE(?Exit),MSG('Exit this application'),STD(STD:Close)
                         END
                         ITEM('Browse && Edit'),USE(?ITEM3)
                         MENU('&Edit'),USE(?EditMenu)
                           ITEM('Cu&t'),USE(?Cut),MSG('Remove item to Windows Clipboard'),STD(STD:Cut)
                           ITEM('&Copy'),USE(?Copy),MSG('Copy item to Windows Clipboard'),STD(STD:Copy)
                           ITEM('&Paste'),USE(?Paste),MSG('Paste contents of Windows Clipboard'),STD(STD:Paste)
                         END
                         MENU('&Window'),USE(?MENU1),MSG('Create and Arrange windows'),STD(STD:WindowList)
                           ITEM('T&ile'),USE(?Tile),MSG('Make all open windows visible'),STD(STD:TileWindow)
                           ITEM('&Cascade'),USE(?Cascade),MSG('Stack all open windows'),STD(STD:CascadeWindow)
                           ITEM('&Arrange Icons'),USE(?Arrange),MSG('Align all window icons'),STD(STD:ArrangeIcons)
                         END
                         MENU('&Help'),USE(?MENU2),MSG('Windows Help')
                           ITEM('&Contents'),USE(?Helpindex),MSG('View the contents of the help file'),STD(STD:HelpIndex)
                           ITEM('&Search for Help On...'),USE(?HelpSearch),MSG('Search for help on a subject'),STD(STD:HelpSearch)
                           ITEM('&How to Use Help'),USE(?HelpOnHelp),MSG('How to use Windows Help'),STD(STD:HelpOnHelp)
                         END
                       END
                     END

ThisWindow           CLASS(WindowManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
TakeAccepted           PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass

  CODE
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It`s called after the window open
!|
!---------------------------------------------------------------------------
Menu::MENUBAR1 ROUTINE                                     ! Code for menu items on ?MENUBAR1
  CASE ACCEPTED()
  OF ?ITEM3
    START(ListTestQ, 25000)
  END
Menu::FileMenu ROUTINE                                     ! Code for menu items on ?FileMenu
Menu::EditMenu ROUTINE                                     ! Code for menu items on ?EditMenu
Menu::MENU1 ROUTINE                                        ! Code for menu items on ?MENU1
Menu::MENU2 ROUTINE                                        ! Code for menu items on ?MENU2

ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('Main')
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = 1
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  !Free(CUS:CustomerQ) 
  
  CUS:CustomerNumber = 1
  CUS:FirstName = 'Joe'
  CUS:LastName = 'Blow'
  CUS:Phone = '123-5678'
  Add(CUS:CustomerQ)
  !stop(CUS:CustomerNumber & ' ' & CUS:FirstName & ' ' & CUS:LastName & ' ' & CUS:Phone)
  CUS:CustomerNumber = 2
  CUS:FirstName = 'John'
  CUS:LastName = 'Adams'
  CUS:Phone = '555-1234'
  Add(CUS:CustomerQ)
  
  CUS:CustomerNumber = 3
  CUS:FirstName = 'George'
  CUS:LastName = 'Carlin'
  CUS:Phone = '555-5678'
  Add(CUS:CustomerQ)
  
  CUS:CustomerNumber = 4
  CUS:FirstName = 'Arnold'
  CUS:LastName = 'Palmer'
  CUS:Phone = '789-5678'
  Add(CUS:CustomerQ)
  SELF.Open(AppFrame)                                      ! Open window
  Do DefineListboxStyle
  INIMgr.Fetch('Main',AppFrame)                            ! Restore window settings from non-volatile store
  SELF.SetAlerts()
  COMPILE ('**CW7**',_VER_C70)
      AppFrame{PROP:TabBarVisible}  = False
  !**CW7**
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.Opened
    INIMgr.Update('Main',AppFrame)                         ! Save window data to non-volatile store
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.TakeAccepted PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receive all EVENT:Accepted's
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
    CASE ACCEPTED()
    ELSE
      DO Menu::MENUBAR1                                    ! Process menu items on ?MENUBAR1 menu
      DO Menu::FileMenu                                    ! Process menu items on ?FileMenu menu
      DO Menu::EditMenu                                    ! Process menu items on ?EditMenu menu
      DO Menu::MENU1                                       ! Process menu items on ?MENU1 menu
      DO Menu::MENU2                                       ! Process menu items on ?MENU2 menu
    END
  ReturnValue = PARENT.TakeAccepted()
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue

ListTestQ PROCEDURE                                        ! Generated from procedure template - Window

Window               WINDOW('Browse Customer Queue'),AT(,,287,109),FONT('Microsoft Sans Serif',10,,FONT:regular, |
  CHARSET:DEFAULT),ALRT(DeleteKey),ALRT(EnterKey),ALRT(InsertKey),GRAY,MDI
                       LIST,AT(4,2,276,75),USE(?LIST1),VSCROLL,FORMAT('60L(2)|M~Customer Number~L(1)@n-14@#2#8' & |
  '0L(2)|M~First Name~L(0)@s20@#3#80L(2)|M~Last Name~L(0)@s20@#4#80L(2)|M~Phone~L(0)@s20@#5#'), |
  FROM(CUS:CustomerQ)
                       BUTTON('&Close'),AT(180,86,39),USE(?BUTTON1)
                       BUTTON('&Add'),AT(50,86,39),USE(?Insert)
                       BUTTON('Chan&ge'),AT(94,86,39),USE(?Change)
                       BUTTON('&Delete'),AT(137,86,39),USE(?Delete)
                     END

ThisWindow           CLASS(WindowManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
TakeAccepted           PROCEDURE(),BYTE,PROC,DERIVED
TakeWindowEvent        PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass

  CODE
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It`s called after the window open
!|
!---------------------------------------------------------------------------

ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('ListTestQ')
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?LIST1
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  SELF.Open(Window)                                        ! Open window
  ?LIST1{PROP:SelStart} = 1  
  Do DefineListboxStyle
  INIMgr.Fetch('ListTestQ',Window)                         ! Restore window settings from non-volatile store
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.Opened
    INIMgr.Update('ListTestQ',Window)                      ! Save window data to non-volatile store
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.TakeAccepted PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receive all EVENT:Accepted's
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
    CASE ACCEPTED()
    OF ?BUTTON1
      Post(Event:CloseWindow)
    OF ?Insert
      Clear(CUS:CustomerQ)
      GlobalRequest = InsertRecord
      UpdateTstQueue
      ?LIST1{PROP:SelStart} = POINTER(CUS:CustomerQ)
      Select(?List1)      
    OF ?Change
      Get(CUS:CustomerQ,Choice(?LIST1))
      GlobalRequest = ChangeRecord
      UpdateTstQueue
      ?LIST1{PROP:SelStart} = POINTER(CUS:CustomerQ)
      Select(?List1)      
    OF ?Delete
      Get(CUS:CustomerQ,Choice(?LIST1))
      Delete(CUS:CustomerQ)
      ?LIST1{PROP:SelStart} = POINTER(CUS:CustomerQ) - 1
      Select(?LIST1)
    END
  ReturnValue = PARENT.TakeAccepted()
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


ThisWindow.TakeWindowEvent PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receives all window specific events
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
    CASE EVENT()
    OF EVENT:AlertKey
      Case KEYCODE()
      Of InsertKey
        Post(Event:Accepted,?Insert)
      Of DeleteKey
        Post(Event:Accepted,?Delete)
      Of EnterKey
        Post(Event:Accepted,?Change)
      End
    END
  ReturnValue = PARENT.TakeWindowEvent()
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue

UpdateTstQueue PROCEDURE                                   ! Generated from procedure template - Window

SAV:TST:Name         STRING(20)                            !
SAV:Customer Like(CUS:Record)
Window               WINDOW('Update Queue Element'),AT(,,156,88),FONT('MS Sans Serif',8,,FONT:regular),RESIZE,GRAY, |
  MDI,SYSTEM
                       PROMPT('Customer Number:'),AT(9,9),USE(?CUS:CustomerNumber:Prompt),RIGHT
                       ENTRY(@n-14),AT(73,8,60,10),USE(CUS:CustomerNumber),RIGHT(1),REQ
                       PROMPT('First Name:'),AT(31,23),USE(?CUS:FirstName:Prompt)
                       ENTRY(@s20),AT(73,22,60,10),USE(CUS:FirstName)
                       PROMPT('Last Name:'),AT(30,37),USE(?CUS:LastName:Prompt)
                       ENTRY(@s20),AT(73,36,60,10),USE(CUS:LastName)
                       PROMPT('Phone:'),AT(45,53),USE(?CUS:Phone:Prompt)
                       ENTRY(@s20),AT(73,52,60,10),USE(CUS:Phone)
                       BUTTON('&OK'),AT(37,71,35,14),USE(?OkButton),LEFT,DEFAULT,REQ
                       BUTTON('&Cancel'),AT(77,71,43,14),USE(?CancelButton),LEFT
                     END

ThisWindow           CLASS(WindowManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
TakeAccepted           PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass

  CODE
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It`s called after the window open
!|
!---------------------------------------------------------------------------

ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('UpdateTstQueue')
  SAV:Customer = CUS:Record
  SELF.Request = GlobalRequest                             ! Store the incoming request
  !stop('GlobalRequest @ INIT is: ' & globalrequest & '<13,10>but GLOBALREQUEST is cleared ' &|
  ! 'a few lines down.<13,10>So, use Self.Request instead.')
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?CUS:CustomerNumber:Prompt
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  SELF.Open(Window)                                        ! Open window
  Do DefineListboxStyle
  INIMgr.Fetch('UpdateTstQueue',Window)                    ! Restore window settings from non-volatile store
  SELF.SetAlerts()
  If Self.Request = InsertRecord
    CUS:CustomerNumber = Records(CUS:CustomerQ) + 1
    Self.FirstField = ?CUS:FirstName
  End  
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.Opened
    INIMgr.Update('UpdateTstQueue',Window)                 ! Save window data to non-volatile store
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.TakeAccepted PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receive all EVENT:Accepted's
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
    CASE ACCEPTED()
    OF ?OkButton
      Case SELF.Request
      Of InsertRecord
        Add(CUS:CustomerQ)
      Of ChangeRecord
        Put(CUS:CustomerQ)
      End 
      Post(Event:CloseWindow)
    OF ?CancelButton
      CUS:Record = SAV:Customer
      Post(Event:CloseWindow)
    END
  ReturnValue = PARENT.TakeAccepted()
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue

